diff -uNr fwbuilder-2.1.8/src/gui/instoptionsdialog_q.ui fwbuilder-2.1.9/src/gui/instoptionsdialog_q.ui
--- fwbuilder-2.1.8/src/gui/instoptionsdialog_q.ui	2006-10-24 06:05:57.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/instoptionsdialog_q.ui	2007-01-06 09:24:57.000000000 +0100
@@ -8,13 +8,37 @@
         <rect>
             <x>0</x>
             <y>0</y>
-            <width>592</width>
-            <height>834</height>
+            <width>589</width>
+            <height>793</height>
         </rect>
     </property>
+    <property name="sizePolicy">
+        <sizepolicy>
+            <hsizetype>5</hsizetype>
+            <vsizetype>0</vsizetype>
+            <horstretch>0</horstretch>
+            <verstretch>0</verstretch>
+        </sizepolicy>
+    </property>
+    <property name="maximumSize">
+        <size>
+            <width>32767</width>
+            <height>32767</height>
+        </size>
+    </property>
+    <property name="font">
+        <font>
+        </font>
+    </property>
     <property name="caption">
         <string>Install options</string>
     </property>
+    <property name="focusPolicy">
+        <enum>StrongFocus</enum>
+    </property>
+    <property name="sizeGripEnabled">
+        <bool>false</bool>
+    </property>
     <vbox>
         <property name="name">
             <cstring>unnamed</cstring>
@@ -65,7 +89,7 @@
             <property name="sizePolicy">
                 <sizepolicy>
                     <hsizetype>5</hsizetype>
-                    <vsizetype>1</vsizetype>
+                    <vsizetype>0</vsizetype>
                     <horstretch>0</horstretch>
                     <verstretch>0</verstretch>
                 </sizepolicy>
@@ -76,11 +100,11 @@
             <property name="frameShadow">
                 <enum>Plain</enum>
             </property>
-            <grid>
+            <vbox>
                 <property name="name">
                     <cstring>unnamed</cstring>
                 </property>
-                <widget class="QLabel" row="0" column="0">
+                <widget class="QLabel">
                     <property name="name">
                         <cstring>textLabel6</cstring>
                     </property>
@@ -88,7 +112,7 @@
                         <string>Enter authentication information below and click 'Next'</string>
                     </property>
                 </widget>
-                <widget class="QLayoutWidget" row="1" column="0">
+                <widget class="QLayoutWidget">
                     <property name="name">
                         <cstring>layout7</cstring>
                     </property>
@@ -168,10 +192,18 @@
                         </spacer>
                     </hbox>
                 </widget>
-                <widget class="QGroupBox" row="2" column="0">
+                <widget class="QGroupBox">
                     <property name="name">
                         <cstring>PIXgroupBox</cstring>
                     </property>
+                    <property name="sizePolicy">
+                        <sizepolicy>
+                            <hsizetype>5</hsizetype>
+                            <vsizetype>0</vsizetype>
+                            <horstretch>0</horstretch>
+                            <verstretch>0</verstretch>
+                        </sizepolicy>
+                    </property>
                     <property name="frameShape">
                         <enum>Box</enum>
                     </property>
@@ -275,7 +307,7 @@
                         </widget>
                     </grid>
                 </widget>
-                <widget class="QLayoutWidget" row="3" column="0">
+                <widget class="QLayoutWidget">
                     <property name="name">
                         <cstring>layout9</cstring>
                     </property>
@@ -309,27 +341,82 @@
                         </widget>
                     </grid>
                 </widget>
-                <spacer row="6" column="0">
+                <widget class="QFrame">
                     <property name="name">
-                        <cstring>spacer36</cstring>
+                        <cstring>frame13</cstring>
                     </property>
-                    <property name="orientation">
-                        <enum>Vertical</enum>
+                    <property name="sizePolicy">
+                        <sizepolicy>
+                            <hsizetype>5</hsizetype>
+                            <vsizetype>0</vsizetype>
+                            <horstretch>0</horstretch>
+                            <verstretch>0</verstretch>
+                        </sizepolicy>
                     </property>
-                    <property name="sizeType">
-                        <enum>Expanding</enum>
+                    <property name="frameShape">
+                        <enum>Box</enum>
                     </property>
-                    <property name="sizeHint">
-                        <size>
-                            <width>20</width>
-                            <height>30</height>
-                        </size>
+                    <property name="frameShadow">
+                        <enum>Plain</enum>
                     </property>
-                </spacer>
-                <widget class="QFrame" row="5" column="0">
+                    <grid>
+                        <property name="name">
+                            <cstring>unnamed</cstring>
+                        </property>
+                        <widget class="QCheckBox" row="0" column="0">
+                            <property name="name">
+                                <cstring>quiet</cstring>
+                            </property>
+                            <property name="text">
+                                <string>Quiet install: do not print anything as commands are executed on the firewall</string>
+                            </property>
+                        </widget>
+                        <widget class="QCheckBox" row="1" column="0">
+                            <property name="name">
+                                <cstring>verbose</cstring>
+                            </property>
+                            <property name="text">
+                                <string>Verbose: print all commands as they are executed on the firewall</string>
+                            </property>
+                        </widget>
+                        <widget class="QCheckBox" row="2" column="0">
+                            <property name="name">
+                                <cstring>stripComments</cstring>
+                            </property>
+                            <property name="text">
+                                <string>Remove comments from configuration</string>
+                            </property>
+                        </widget>
+                        <widget class="QCheckBox" row="3" column="0">
+                            <property name="name">
+                                <cstring>compressScript</cstring>
+                            </property>
+                            <property name="text">
+                                <string>Compress script</string>
+                            </property>
+                        </widget>
+                        <widget class="QCheckBox" row="4" column="0">
+                            <property name="name">
+                                <cstring>copyFWB</cstring>
+                            </property>
+                            <property name="text">
+                                <string>Store a copy of fwb file on the firewall</string>
+                            </property>
+                        </widget>
+                    </grid>
+                </widget>
+                <widget class="QFrame">
                     <property name="name">
                         <cstring>frame5</cstring>
                     </property>
+                    <property name="sizePolicy">
+                        <sizepolicy>
+                            <hsizetype>5</hsizetype>
+                            <vsizetype>0</vsizetype>
+                            <horstretch>0</horstretch>
+                            <verstretch>0</verstretch>
+                        </sizepolicy>
+                    </property>
                     <property name="frameShape">
                         <enum>Box</enum>
                     </property>
@@ -439,71 +526,7 @@
                         </spacer>
                     </grid>
                 </widget>
-                <widget class="QFrame" row="4" column="0">
-                    <property name="name">
-                        <cstring>frame13</cstring>
-                    </property>
-                    <property name="sizePolicy">
-                        <sizepolicy>
-                            <hsizetype>5</hsizetype>
-                            <vsizetype>5</vsizetype>
-                            <horstretch>0</horstretch>
-                            <verstretch>0</verstretch>
-                        </sizepolicy>
-                    </property>
-                    <property name="frameShape">
-                        <enum>Box</enum>
-                    </property>
-                    <property name="frameShadow">
-                        <enum>Plain</enum>
-                    </property>
-                    <grid>
-                        <property name="name">
-                            <cstring>unnamed</cstring>
-                        </property>
-                        <widget class="QCheckBox" row="0" column="0">
-                            <property name="name">
-                                <cstring>quiet</cstring>
-                            </property>
-                            <property name="text">
-                                <string>Quiet install: do not print anything as commands are executed on the firewall</string>
-                            </property>
-                        </widget>
-                        <widget class="QCheckBox" row="1" column="0">
-                            <property name="name">
-                                <cstring>verbose</cstring>
-                            </property>
-                            <property name="text">
-                                <string>Verbose: print all commands as they are executed on the firewall</string>
-                            </property>
-                        </widget>
-                        <widget class="QCheckBox" row="2" column="0">
-                            <property name="name">
-                                <cstring>stripComments</cstring>
-                            </property>
-                            <property name="text">
-                                <string>Remove comments from configuration</string>
-                            </property>
-                        </widget>
-                        <widget class="QCheckBox" row="3" column="0">
-                            <property name="name">
-                                <cstring>compressScript</cstring>
-                            </property>
-                            <property name="text">
-                                <string>Compress script</string>
-                            </property>
-                        </widget>
-                        <widget class="QCheckBox" row="4" column="0">
-                            <property name="name">
-                                <cstring>copyFWB</cstring>
-                            </property>
-                            <property name="text">
-                                <string>Store a copy of fwb file on the firewall</string>
-                            </property>
-                        </widget>
-                    </grid>
-                </widget>
-            </grid>
+            </vbox>
         </widget>
         <widget class="QLayoutWidget">
             <property name="name">
@@ -588,6 +611,10 @@
     <tabstop>okButton</tabstop>
     <tabstop>cancelButton</tabstop>
 </tabstops>
+<functions>
+    <function>hidePIXOptions()</function>
+    <function>hideOption(QWidget *w)</function>
+</functions>
 <pixmapinproject/>
 <layoutdefaults spacing="6" margin="11"/>
 </UI>
diff -uNr fwbuilder-2.1.8/src/gui/ipfAdvancedDialog.cpp fwbuilder-2.1.9/src/gui/ipfAdvancedDialog.cpp
--- fwbuilder-2.1.8/src/gui/ipfAdvancedDialog.cpp	2006-04-11 06:26:26.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ipfAdvancedDialog.cpp	2007-01-06 23:03:25.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ipfAdvancedDialog.cpp,v 1.15 2006/04/11 04:26:26 vkurland Exp $
+  $Id: ipfAdvancedDialog.cpp,v 1.16 2007/01/06 22:03:25 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -163,7 +163,8 @@
 
 void ipfAdvancedDialog::editProlog()
 {
-    SimpleTextEditor edt( prolog_script->text(),
+    SimpleTextEditor edt(this,
+                         prolog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         prolog_script->setText( edt.text() );
@@ -171,7 +172,8 @@
 
 void ipfAdvancedDialog::editEpilog()
 {
-    SimpleTextEditor edt( epilog_script->text(),
+    SimpleTextEditor edt(this,
+                         epilog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         epilog_script->setText( edt.text() );
diff -uNr fwbuilder-2.1.8/src/gui/ipfwAdvancedDialog.cpp fwbuilder-2.1.9/src/gui/ipfwAdvancedDialog.cpp
--- fwbuilder-2.1.8/src/gui/ipfwAdvancedDialog.cpp	2006-10-07 08:16:54.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ipfwAdvancedDialog.cpp	2007-01-06 23:03:25.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ipfwAdvancedDialog.cpp,v 1.12 2006/10/07 06:16:54 vkurland Exp $
+  $Id: ipfwAdvancedDialog.cpp,v 1.13 2007/01/06 22:03:25 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -139,7 +139,8 @@
 
 void ipfwAdvancedDialog::editProlog()
 {
-    SimpleTextEditor edt( prolog_script->text(),
+    SimpleTextEditor edt(this,
+                         prolog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         prolog_script->setText( edt.text() );
@@ -147,7 +148,8 @@
 
 void ipfwAdvancedDialog::editEpilog()
 {
-    SimpleTextEditor edt( epilog_script->text(),
+    SimpleTextEditor edt(this,
+                         epilog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         epilog_script->setText( edt.text() );
diff -uNr fwbuilder-2.1.8/src/gui/iptAdvancedDialog.cpp fwbuilder-2.1.9/src/gui/iptAdvancedDialog.cpp
--- fwbuilder-2.1.8/src/gui/iptAdvancedDialog.cpp	2006-03-16 06:38:14.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/iptAdvancedDialog.cpp	2007-01-15 05:37:52.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: iptAdvancedDialog.cpp,v 1.26 2006/03/16 05:38:14 vkurland Exp $
+  $Id: iptAdvancedDialog.cpp,v 1.28 2007/01/15 04:37:52 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -94,40 +94,43 @@
     logLimitSuffix->insertStringList(getScreenNames(slm));
     data.registerOption( logLimitSuffix,   fwoptions,  "limit_suffix", slm); 
     
-    data.registerOption(logLimitVal,          fwoptions, "limit_value"                          );
-    data.registerOption(logAll,               fwoptions, "log_all"                              );
-    data.registerOption(compiler,             fwoptions, "compiler"                             );
-    data.registerOption(compilerArgs,         fwoptions, "cmdline"                              );
-    data.registerOption(outputFileName,       fwoptions, "output_file"                          );
-    data.registerOption(assumeFwIsPartOfAny,  fwoptions, "firewall_is_part_of_any_and_networks" );
-    data.registerOption(acceptSessions,       fwoptions, "accept_new_tcp_with_no_syn"           );
-    data.registerOption(dropInvalid,          fwoptions, "drop_invalid"                         );
-    data.registerOption(logInvalid,           fwoptions, "log_invalid"                          );
-    data.registerOption(acceptESTBeforeFirst, fwoptions, "accept_established"                   );
-    data.registerOption(bridge,               fwoptions, "bridging_fw"                          );
-    data.registerOption(shadowing,            fwoptions, "check_shading"                        );
-    data.registerOption(emptyGroups,          fwoptions, "ignore_empty_groups"                  );
-    data.registerOption(localNAT,             fwoptions, "local_nat"                            );
-    data.registerOption(clampMSStoMTU,        fwoptions, "clamp_mss_to_mtu"                     );
+    data.registerOption(logLimitVal,          fwoptions, "limit_value");
+    data.registerOption(logAll,               fwoptions, "log_all");
+    data.registerOption(compiler,             fwoptions, "compiler");
+    data.registerOption(compilerArgs,         fwoptions, "cmdline");
+    data.registerOption(outputFileName,       fwoptions, "output_file");
+    data.registerOption(assumeFwIsPartOfAny,  fwoptions, "firewall_is_part_of_any_and_networks");
+    data.registerOption(acceptSessions,       fwoptions, "accept_new_tcp_with_no_syn");
+    data.registerOption(dropInvalid,          fwoptions, "drop_invalid");
+    data.registerOption(logInvalid,           fwoptions, "log_invalid");
+    data.registerOption(acceptESTBeforeFirst, fwoptions, "accept_established");
+    data.registerOption(bridge,               fwoptions, "bridging_fw");
+    data.registerOption(shadowing,            fwoptions, "check_shading");
+    data.registerOption(emptyGroups,          fwoptions, "ignore_empty_groups");
+    data.registerOption(localNAT,             fwoptions, "local_nat");
+    data.registerOption(clampMSStoMTU,        fwoptions, "clamp_mss_to_mtu");
+    data.registerOption(makeTagClassifyTerminating,
+                                              fwoptions, "classify_mark_terminating");
 
     slm=getActionsOnReject( obj->getStr("platform").c_str() );
     actionOnReject->clear();
     actionOnReject->insertStringList(getScreenNames(slm));
-    data.registerOption( actionOnReject,   fwoptions,"action_on_reject", slm); 
+    data.registerOption( actionOnReject,      fwoptions,"action_on_reject", slm); 
     
-    data.registerOption(mgmt_ssh    ,fwoptions, "mgmt_ssh"    );
-    data.registerOption(mgmt_addr    ,fwoptions, "mgmt_addr"    );
-    data.registerOption(addVirtualsforNAT    ,fwoptions, "manage_virtual_addr"    );
-    data.registerOption(configureInterfaces    ,fwoptions, "configure_interfaces"    );
-    data.registerOption(iptDebug    ,fwoptions, "debug"    );
-    data.registerOption(verifyInterfaces    ,fwoptions, "verify_interfaces"    );
-    data.registerOption(loadModules    ,fwoptions, "load_modules"    );
-    data.registerOption(iptablesRestoreActivation    ,fwoptions, "use_iptables_restore"    );
-    data.registerOption(ipt_fw_dir    ,fwoptions, "firewall_dir"    );
-    data.registerOption(ipt_user    ,fwoptions, "admUser"    );
-    data.registerOption(altAddress    ,fwoptions, "altAddress"    );
-    data.registerOption(sshArgs    ,fwoptions, "sshArgs"    );
-    data.registerOption(activationCmd    ,fwoptions, "activationCmd"    );
+    data.registerOption(mgmt_ssh,             fwoptions, "mgmt_ssh"    );
+    data.registerOption(mgmt_addr,            fwoptions, "mgmt_addr"    );
+    data.registerOption(addVirtualsforNAT,    fwoptions, "manage_virtual_addr"    );
+    data.registerOption(configureInterfaces,  fwoptions, "configure_interfaces"    );
+    data.registerOption(iptDebug,             fwoptions, "debug"    );
+    data.registerOption(verifyInterfaces,     fwoptions, "verify_interfaces"    );
+    data.registerOption(loadModules,          fwoptions, "load_modules"    );
+    data.registerOption(iptablesRestoreActivation,
+                                              fwoptions, "use_iptables_restore"    );
+    data.registerOption(ipt_fw_dir,           fwoptions, "firewall_dir"    );
+    data.registerOption(ipt_user,             fwoptions, "admUser"    );
+    data.registerOption(altAddress,           fwoptions, "altAddress"    );
+    data.registerOption(sshArgs,              fwoptions, "sshArgs"    );
+    data.registerOption(activationCmd,        fwoptions, "activationCmd"    );
 
 
     PolicyInstallScript *pis   = mgmt->getPolicyInstallScript();
@@ -212,7 +215,8 @@
 
 void iptAdvancedDialog::editProlog()
 {
-    SimpleTextEditor edt( prolog_script->text(),
+    SimpleTextEditor edt(this,
+                         prolog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         prolog_script->setText( edt.text() );
@@ -220,7 +224,8 @@
 
 void iptAdvancedDialog::editEpilog()
 {
-    SimpleTextEditor edt( epilog_script->text(),
+    SimpleTextEditor edt(this,
+                         epilog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         epilog_script->setText( edt.text() );
